#!/usr/bin/perl

#    ADC2000NG - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

binmode STDIN;
read (STDIN,$buf,$ENV{CONTENT_LENGTH});
($day,$month,$date,$time,$year)=split(" ",scalar gmtime(time+$gmtzone*3600));
$pdate="$month $date $year";
($boundary)=$ENV{CONTENT_TYPE}=~/boundary="([^"]+)"/; #";
($boundary)=$ENV{CONTENT_TYPE}=~/boundary=(\S+)/ unless $boundary;
$boundary="--".$boundary;
@file=split("\r\n$boundary",$buf);
foreach (@file)
{
	s/\r\n\r\n/delimeter/;
}
($field,$data{name})=split("delimeter",$file[0]);
($field,$data{lang})=split("delimeter",$file[1]);
($field,$data{password})=split("delimeter",$file[2]);
($field,$data{spot})=split("delimeter",$file[3]);
($field,$data{method})=split("delimeter",$file[4]);
($field,$file)=split("delimeter",$file[5]);
$name=$data{name};
$spot=$data{spot};
$field=~s/filename\=//;
$field=~s/\"//g;
@field=split(/\./,$field);
$exten=pop(@field);
($exten)=split(" ",$exten);
$filenm=join("",@field);
$exten=~tr/A-Z/a-z/;
$selected{str}="selected";
$selectede{manstr}="selected";
open (F, "<$adcpath/langpack/$data{lang}.mtd");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
open (F, "<$adcpath/langpack/$data{lang}.spb");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
if (($exten eq "jpg" || $exten eq "gif") && length($file)<=$sbsize)
{
	if (-e "$basepath/$data{name}/autoaccept" || $autoaccept)
	{
	unlink ("$adcpath/sb/$data{name}.gif");
	unlink ("$adcpath/sb/$data{name}.jpg");
	unlink ("$adcpath/sb/$data{name}.ext");
	open (F,">$adcpath/sb/$name.$exten");
	flock(F,$LOCK_EX);
	binmode F;
	print F $file;
	flock(F,$LOCK_UN);
	close (F);
	if (-e "$adcpath/sb/$data{name}.gif")
	{
		$bannerco="<br><img src=\"$adcenter/sb/$data{name}.gif\" width=$sbwidth height=$sbheight>";
	}
	elsif (-e "$adcpath/sb/$data{name}.jpg")
	{
		$bannerco="<br><img src=\"$adcenter/sb/$data{name}.jpg\" width=$sbwidth height=$sbheight>";
	}
	open (FL, "<$adcpath/template/$data{lang}/musbstr.tpl");
	@htmlpage=<FL>;
	close (FL);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
	}
	unlink ("$adcpath/queye/sb/$data{name}.gif");
	unlink ("$adcpath/queye/sb/$data{name}.jpg");
	unlink ("$adcpath/queye/sb/$data{name}.ext");
	open (F,">$adcpath/queye/sb/$name.$exten");
	flock(F,$LOCK_EX);
	binmode F;
	print F $file;
	flock(F,$LOCK_UN);
	close (F);
	if (-e "$adcpath/queye/sb/$data{name}.gif")
	{
		$bannerco="<br><img src=\"$adcenter/queye/sb/$data{name}.gif\" width=$sbwidth height=$sbheight>";
	}
	elsif (-e "$adcpath/queye/sb/$data{name}.jpg")
	{
		$bannerco="<br><img src=\"$adcenter/queye/sb/$data{name}.jpg\" width=$sbwidth height=$sbheight>";
	}
	open (FL, "<$adcpath/template/$data{lang}/musbstr.tpl");
	@htmlpage=<FL>;
	close (FL);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
open (F, "<$adcpath/langpack/$data{lang}.msg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
push (@errors, $rep[1]);
open (FL, "<$adcpath/template/$data{lang}/meusstr.tpl");
@htmlpage=<FL>;
close (FL);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
