#!/usr/bin/perl

#    ADC2000NG - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

($username,$variant)=split("&",$ENV{QUERY_STRING});
@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cookie{$field}=$value;
	}
}
$temp="ngcount$username";
($ldate=scalar gmtime(time+$gmtzone*3600))=~s/ \d+:\d+:\d+//;
($day,$month,$date,$time,$year)=split(" ",scalar gmtime(time+$gmtzone*3600));
($hours)=split(":",$time);
unless (-e "$basepath/$username/counter.cmn")
{
	open (F,">$basepath/$username/counter.cmn");
	flock(F,$LOCK_EX);
	flock(F,$LOCK_UN);
	close (F);
}
open (STAT,"+<$basepath/$username/counter.cmn");
flock(STAT,$LOCK_EX);
while($line=<STAT>)
{
	chop($line);
	($tkey,$tval)=split("\t",$line);
	$stats{$tkey}=$tval;
}
@stats=split ("#",$stats{$ldate});
$stats[$hours]=$stats[$hours]+1;
$stats{$ldate}=join("#",@stats[0..23]);
truncate(STAT,0);
seek(STAT,0,0);
foreach $key (keys %stats){print STAT "$key\t$stats{$key}\n";}
flock(STAT,$LOCK_UN);
close (STAT);
unless ($cookie{$temp})
{
	unless (-e "$basepath/$username/counter.unq")
	{
		open (F,">$basepath/$username/counter.unq");
		flock(F,$LOCK_EX);
		flock(F,$LOCK_UN);
		close (F);
	}
	open (STAT,"+<$basepath/$username/counter.unq");
	flock(STAT,$LOCK_EX);
	while($line=<STAT>)
	{
		chop($line);
		($tkey,$tval)=split("\t",$line);
		$statsu{$tkey}=$tval;
	}
	@stats=split ("#",$statsu{$ldate});
	$stats[$hours]=$stats[$hours]+1;
	$statsu{$ldate}=join("#",@stats[0..23]);
	truncate(STAT,0);
	seek(STAT,0,0);
	foreach $key (keys %statsu){print STAT "$key\t$statsu{$key}\n";}
	flock(STAT,$LOCK_UN);
	close (STAT);
}
if ($usegd)
{
	$scriptfile="adccountgd.pl";
	$hco=15;
}
else
{
	$scriptfile="adccount.pl";
	$hco=10;
}
print "HTTP/1.0 200 OK\n";
print "P3P: CP=\"UNI\"\n";
print "set-cookie: ngcount$username=1; expires=Sunday, 31-Dec-$year 23:59:59 GMT \n";
print "content-type: application/x-javascript\n\n";
print qq~if (screen.width==640&&screen.height==480) {var resol="r640"}
else if (screen.width==800&&screen.height==600) {var resol="r800"}
else if (screen.width==1024&&screen.height==768) {var resol="r1024"}
else {var resol="rother"}
document.write('<table width=80 height=42 border=0 cellpadding=0 cellspacing=0 background="$adcenter/images/counter.gif"><tr><td align=center valign=center><a href="$furl" target="_top"><img border=0 width=64 height=$hco alt="$counteralt" src="$cgi/$scriptfile?$username&$variant&'+resol+'&'+Math.random()+'"></a></td></tr></table>');~;
